Index: uspace/srv/hw/irc/apic/apic.c
===================================================================
--- uspace/srv/hw/irc/apic/apic.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/hw/irc/apic/apic.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,7 +36,6 @@
  */
 
-#include <ipc/services.h>
 #include <ipc/irc.h>
-#include <ns.h>
+#include <loc.h>
 #include <sysinfo.h>
 #include <as.h>
@@ -185,4 +184,8 @@
 			async_answer_0(callid, apic_enable_irq(IPC_GET_ARG1(call)));
 			break;
+		case IRC_DISABLE_INTERRUPT:
+			/* XXX TODO */
+			async_answer_0(callid, EOK);
+			break;
 		case IRC_CLEAR_INTERRUPT:
 			/* Noop */
@@ -202,4 +205,6 @@
 {
 	sysarg_t apic;
+	category_id_t irc_cat;
+	service_id_t svc_id;
 	
 	if ((sysinfo_get_value("apic", &apic) != EOK) || (!apic)) {
@@ -216,5 +221,30 @@
 	
 	async_set_fallback_port_handler(apic_connection, NULL);
-	service_register(SERVICE_IRC);
+	
+	rc = loc_server_register(NAME);
+	if (rc != EOK) {
+		printf("%s: Failed registering server. (%d)\n", NAME, rc);
+		return false;
+	}
+	
+	rc = loc_service_register("irc/" NAME, &svc_id);
+	if (rc != EOK) {
+		printf("%s: Failed registering service. (%d)\n", NAME, rc);
+		return false;
+	}
+	
+	rc = loc_category_get_id("irc", &irc_cat, IPC_FLAG_BLOCKING);
+	if (rc != EOK) {
+		printf("%s: Failed resolving category 'iplink' (%d).\n", NAME,
+		    rc);
+		return false;
+	}
+	
+	rc = loc_service_add_to_cat(svc_id, irc_cat);
+	if (rc != EOK) {
+		printf("%s: Failed adding service to category (%d).\n", NAME,
+		    rc);
+		return false;
+	}
 	
 	return true;
Index: uspace/srv/hw/irc/i8259/i8259.c
===================================================================
--- uspace/srv/hw/irc/i8259/i8259.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/hw/irc/i8259/i8259.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,7 +36,6 @@
  */
 
-#include <ipc/services.h>
 #include <ipc/irc.h>
-#include <ns.h>
+#include <loc.h>
 #include <sysinfo.h>
 #include <as.h>
@@ -47,5 +46,4 @@
 #include <async.h>
 #include <stdio.h>
-#include <ipc/loc.h>
 
 #define NAME  "i8259"
@@ -120,4 +118,8 @@
 			async_answer_0(callid, pic_enable_irq(IPC_GET_ARG1(call)));
 			break;
+		case IRC_DISABLE_INTERRUPT:
+			/* XXX TODO */
+			async_answer_0(callid, EOK);
+			break;
 		case IRC_CLEAR_INTERRUPT:
 			/* Noop */
@@ -137,4 +139,7 @@
 {
 	sysarg_t i8259;
+	category_id_t irc_cat;
+	service_id_t svc_id;
+	int rc;
 	
 	if ((sysinfo_get_value("i8259", &i8259) != EOK) || (!i8259)) {
@@ -152,5 +157,30 @@
 	
 	async_set_fallback_port_handler(i8259_connection, NULL);
-	service_register(SERVICE_IRC);
+
+	rc = loc_server_register(NAME);
+	if (rc != EOK) {
+		printf("%s: Failed registering server. (%d)\n", NAME, rc);
+		return false;
+	}
+
+	rc = loc_service_register("irc/" NAME, &svc_id);
+	if (rc != EOK) {
+		printf("%s: Failed registering service. (%d)\n", NAME, rc);
+		return false;
+	}
+
+	rc = loc_category_get_id("irc", &irc_cat, IPC_FLAG_BLOCKING);
+	if (rc != EOK) {
+		printf("%s: Failed resolving category 'iplink' (%d).\n", NAME,
+		    rc);
+		return false;
+	}
+
+	rc = loc_service_add_to_cat(svc_id, irc_cat);
+	if (rc != EOK) {
+		printf("%s: Failed adding service to category (%d).\n", NAME,
+		    rc);
+		return false;
+	}
 	
 	return true;
Index: uspace/srv/hw/irc/obio/obio.c
===================================================================
--- uspace/srv/hw/irc/obio/obio.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/hw/irc/obio/obio.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -42,10 +42,10 @@
  */
 
-#include <ipc/services.h>
 #include <ipc/irc.h>
-#include <ns.h>
+#include <loc.h>
 #include <as.h>
 #include <ddi.h>
 #include <align.h>
+#include <inttypes.h>
 #include <stdbool.h>
 #include <errno.h>
@@ -54,9 +54,8 @@
 #include <async.h>
 #include <stdio.h>
-#include <ipc/loc.h>
 
 #define NAME "obio"
 
-#define OBIO_SIZE	0x1898	
+#define OBIO_SIZE	0x1898
 
 #define OBIO_IMR_BASE	0x200
@@ -97,4 +96,8 @@
 			async_answer_0(callid, EOK);
 			break;
+		case IRC_DISABLE_INTERRUPT:
+			/* XXX TODO */
+			async_answer_0(callid, EOK);
+			break;
 		case IRC_CLEAR_INTERRUPT:
 			inr = IPC_GET_ARG1(call);
@@ -115,4 +118,8 @@
 static bool obio_init(void)
 {
+	category_id_t irc_cat;
+	service_id_t svc_id;
+	int rc;
+	
 	base_phys = (uintptr_t) 0x1fe00000000ULL;
 	
@@ -127,8 +134,33 @@
 	}
 	
-	printf("%s: OBIO registers with base at %lx\n", NAME, base_phys);
+	printf("%s: OBIO registers with base at 0x%" PRIun "\n", NAME, base_phys);
 	
 	async_set_fallback_port_handler(obio_connection, NULL);
-	service_register(SERVICE_IRC);
+	
+	rc = loc_server_register(NAME);
+	if (rc != EOK) {
+		printf("%s: Failed registering server. (%d)\n", NAME, rc);
+		return false;
+	}
+	
+	rc = loc_service_register("irc/" NAME, &svc_id);
+	if (rc != EOK) {
+		printf("%s: Failed registering service. (%d)\n", NAME, rc);
+		return false;
+	}
+	
+	rc = loc_category_get_id("irc", &irc_cat, IPC_FLAG_BLOCKING);
+	if (rc != EOK) {
+		printf("%s: Failed resolving category 'iplink' (%d).\n", NAME,
+		    rc);
+		return false;
+	}
+	
+	rc = loc_service_add_to_cat(svc_id, irc_cat);
+	if (rc != EOK) {
+		printf("%s: Failed adding service to category (%d).\n", NAME,
+		    rc);
+		return false;
+	}
 	
 	return true;
Index: uspace/srv/locsrv/locsrv.c
===================================================================
--- uspace/srv/locsrv/locsrv.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/locsrv/locsrv.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -1359,4 +1359,7 @@
 	categ_dir_add_cat(&cdir, cat);
 
+	cat = category_new("irc");
+	categ_dir_add_cat(&cdir, cat);
+
 	cat = category_new("visualizer");
 	categ_dir_add_cat(&cdir, cat);
Index: uspace/srv/net/dhcp/transport.c
===================================================================
--- uspace/srv/net/dhcp/transport.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/dhcp/transport.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -153,4 +153,10 @@
 	}
 
+	rc = udp_assoc_set_nolocal(assoc);
+	if (rc != EOK) {
+		rc = EIO;
+		goto error;
+	}
+
 	dt->udp = udp;
 	dt->assoc = assoc;
Index: uspace/srv/net/dnsrsrv/dns_msg.c
===================================================================
--- uspace/srv/net/dnsrsrv/dns_msg.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/dnsrsrv/dns_msg.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -77,5 +77,5 @@
 		return ENOMEM;
 
-	str_cpy((*dstr) + s1, nsize - s1, suff);
+	str_cpy(nstr + s1, nsize - s1, suff);
 
 	*dstr = nstr;
@@ -195,12 +195,4 @@
 			break;
 
-		if (!first) {
-			rc = dns_dstr_ext(&name, ".");
-			if (rc != EOK) {
-				rc = ENOMEM;
-				goto error;
-			}
-		}
-
 		if ((lsize & 0xc0) == 0xc0) {
 			/* Pointer */
@@ -233,5 +225,6 @@
 			 * the message continues
 			 */
-			*eoff = eptr;
+			if (*eoff == 0)
+				*eoff = eptr;
 
 			bp = pdu->data + ptr;
@@ -243,4 +236,12 @@
 			rc = EINVAL;
 			goto error;
+		}
+
+		if (!first) {
+			rc = dns_dstr_ext(&name, ".");
+			if (rc != EOK) {
+				rc = ENOMEM;
+				goto error;
+			}
 		}
 
@@ -413,5 +414,5 @@
 	rc = dns_name_decode(pdu, boff, &rr->name, &name_eoff);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_DEBUG, "Error decoding name");
+		log_msg(LOG_DEFAULT, LVL_DEBUG, "dns_rr_decode: error decoding name");
 		free(rr);
 		return ENOMEM;
@@ -421,4 +422,5 @@
 		free(rr->name);
 		free(rr);
+		log_msg(LOG_DEFAULT, LVL_DEBUG, "dns_rr_decode: error name_off");
 		return EINVAL;
 	}
@@ -430,4 +432,5 @@
 		free(rr->name);
 		free(rr);
+		log_msg(LOG_DEFAULT, LVL_DEBUG, "dns_rr_decode: error bsz");
 		return EINVAL;
 	}
@@ -445,4 +448,7 @@
 	bsz -= sizeof(uint32_t);
 
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "dns_rr_decode: rtype=0x%x, rclass=0x%x, ttl=0x%x",
+	    rr->rtype, rr->rclass, rr->ttl );
+
 	rdlength = dns_uint16_t_decode(bp, bsz);
 	bp += sizeof(uint16_t);
@@ -452,12 +458,15 @@
 		free(rr->name);
 		free(rr);
+		log_msg(LOG_DEFAULT, LVL_DEBUG, "dns_rr_decode: Error rdlength %zu > bsz %zu", rdlength, bsz);
 		return EINVAL;
 	}
 
 	rr->rdata_size = rdlength;
-	rr->rdata = calloc(1, sizeof(rdlength));
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "dns_rr_decode: rdlength=%zu", rdlength);
+	rr->rdata = calloc(1, rdlength);
 	if (rr->rdata == NULL) {
 		free(rr->name);
 		free(rr);
+		log_msg(LOG_DEFAULT, LVL_DEBUG, "dns_rr_decode: Error memory");
 		return ENOMEM;
 	}
@@ -470,4 +479,5 @@
 	*eoff = bp - pdu->data;
 	*retrr = rr;
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "dns_rr_decode: done");
 	return EOK;
 }
@@ -586,5 +596,5 @@
 	memcpy(msg->pdu.data, data, size);
 	msg->pdu.size = size;
-	log_msg(LOG_DEFAULT, LVL_NOTE, "dns_message_decode: pdu->data = %p, "
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "dns_message_decode: pdu->data = %p, "
 	    "pdu->size=%zu", msg->pdu.data, msg->pdu.size);
 
@@ -605,4 +615,6 @@
 
 	qd_count = uint16_t_be2host(hdr->qd_count);
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "qd_count=%zu", qd_count);
+
 
 	for (i = 0; i < qd_count; i++) {
@@ -618,4 +630,5 @@
 
 	an_count = uint16_t_be2host(hdr->an_count);
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "an_count=%zu", an_count);
 
 	for (i = 0; i < an_count; i++) {
Index: uspace/srv/net/dnsrsrv/query.c
===================================================================
--- uspace/srv/net/dnsrsrv/query.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/dnsrsrv/query.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -90,4 +90,5 @@
 	list_append(&question->msg, &msg->question);
 	
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "dns_name_query: send DNS request");
 	dns_message_t *amsg;
 	int rc = dns_request(msg, &amsg);
Index: uspace/srv/net/dnsrsrv/transport.c
===================================================================
--- uspace/srv/net/dnsrsrv/transport.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/dnsrsrv/transport.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -183,4 +183,5 @@
 	void *req_data;
 	size_t req_size;
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "dns_request: Encode dns message");
 	int rc = dns_message_encode(req, &req_data, &req_size);
 	if (rc != EOK)
@@ -194,8 +195,11 @@
 
 	while (ntry < REQ_RETRY_MAX) {
+		log_msg(LOG_DEFAULT, LVL_DEBUG, "dns_request: Send DNS message");
 		rc = udp_assoc_send_msg(transport_assoc, &ep, req_data,
 		    req_size);
-		if (rc != EOK)
+		if (rc != EOK) {
+			log_msg(LOG_DEFAULT, LVL_DEBUG, "Error %d sending message", rc);
 			goto error;
+		}
 
 		treq = treq_create(req);
Index: uspace/srv/net/inetsrv/inet_link.c
===================================================================
--- uspace/srv/net/inetsrv/inet_link.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/inetsrv/inet_link.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -111,5 +111,5 @@
 	}
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "inet_iplink_recv: link_id=%zu", packet.link_id);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "inet_iplink_recv: link_id=%zu", packet.link_id);
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "call inet_recv_packet()");
 	rc = inet_recv_packet(&packet);
Index: uspace/srv/net/inetsrv/inetsrv.c
===================================================================
--- uspace/srv/net/inetsrv/inetsrv.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/inetsrv/inetsrv.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -450,5 +450,5 @@
 	ipc_call_t answer;
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "inet_ev_recv: iplink=%zu",
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "inet_ev_recv: iplink=%zu",
 	    dgram->iplink);
 
Index: uspace/srv/net/tcp/Makefile
===================================================================
--- uspace/srv/net/tcp/Makefile	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/tcp/Makefile	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,6 +37,7 @@
 BINARY = tcp
 
-SOURCES = \
+SOURCES_COMMON = \
 	conn.c \
+	inet.c \
 	iqueue.c \
 	ncsim.c \
@@ -44,10 +45,25 @@
 	rqueue.c \
 	segment.c \
-	service.c \
 	seq_no.c \
-	tcp.c \
 	test.c \
 	tqueue.c \
 	ucall.c
 
+SOURCES = \
+	$(SOURCES_COMMON) \
+	service.c \
+	tcp.c
+
+TEST_SOURCES = \
+	$(SOURCES_COMMON) \
+	test/conn.c \
+	test/iqueue.c \
+	test/main.c \
+	test/pdu.c \
+	test/rqueue.c \
+	test/segment.c \
+	test/seq_no.c \
+	test/tqueue.c \
+	test/ucall.c
+
 include $(USPACE_PREFIX)/Makefile.common
Index: uspace/srv/net/tcp/conn.c
===================================================================
--- uspace/srv/net/tcp/conn.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/tcp/conn.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -44,5 +44,8 @@
 #include <stdlib.h>
 #include "conn.h"
+#include "inet.h"
 #include "iqueue.h"
+#include "pdu.h"
+#include "rqueue.h"
 #include "segment.h"
 #include "seq_no.h"
@@ -57,12 +60,26 @@
 #define TIME_WAIT_TIMEOUT	(2*MAX_SEGMENT_LIFETIME)
 
+/** List of all allocated connections */
 static LIST_INITIALIZE(conn_list);
 /** Taken after tcp_conn_t lock */
 static FIBRIL_MUTEX_INITIALIZE(conn_list_lock);
+/** Connection association map */
 static amap_t *amap;
-
-static void tcp_conn_seg_process(tcp_conn_t *conn, tcp_segment_t *seg);
-static void tcp_conn_tw_timer_set(tcp_conn_t *conn);
-static void tcp_conn_tw_timer_clear(tcp_conn_t *conn);
+/** Taken after tcp_conn_t lock */
+static FIBRIL_MUTEX_INITIALIZE(amap_lock);
+
+/** Internal loopback configuration */
+tcp_lb_t tcp_conn_lb = tcp_lb_none;
+
+static void tcp_conn_seg_process(tcp_conn_t *, tcp_segment_t *);
+static void tcp_conn_tw_timer_set(tcp_conn_t *);
+static void tcp_conn_tw_timer_clear(tcp_conn_t *);
+static void tcp_transmit_segment(inet_ep2_t *, tcp_segment_t *);
+static void tcp_conn_trim_seg_to_wnd(tcp_conn_t *, tcp_segment_t *);
+static void tcp_reply_rst(inet_ep2_t *, tcp_segment_t *);
+
+static tcp_tqueue_cb_t tcp_conn_tqueue_cb = {
+	.transmit_seg = tcp_transmit_segment
+};
 
 /** Initialize connections. */
@@ -78,4 +95,13 @@
 
 	return EOK;
+}
+
+/** Finalize connections. */
+void tcp_conns_fini(void)
+{
+	assert(list_empty(&conn_list));
+
+	amap_destroy(amap);
+	amap = NULL;
 }
 
@@ -130,6 +156,8 @@
 
 	/* Initialize retransmission queue */
-	if (tcp_tqueue_init(&conn->retransmit, conn) != EOK)
+	if (tcp_tqueue_init(&conn->retransmit, conn, &tcp_conn_tqueue_cb)
+	    != EOK) {
 		goto error;
+	}
 
 	tqueue_inited = true;
@@ -147,4 +175,8 @@
 	if (epp != NULL)
 		conn->ident = *epp;
+
+	fibril_mutex_lock(&conn_list_lock);
+	list_append(&conn->link, &conn_list);
+	fibril_mutex_unlock(&conn_list_lock);
 
 	return conn;
@@ -181,5 +213,11 @@
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "%s: tcp_conn_free(%p)", conn->name, conn);
+
+	assert(conn->mapped == false);
 	tcp_tqueue_fini(&conn->retransmit);
+
+	fibril_mutex_lock(&conn_list_lock);
+	list_remove(&conn->link);
+	fibril_mutex_unlock(&conn_list_lock);
 
 	if (conn->rcv_buf != NULL)
@@ -271,5 +309,5 @@
 
 	tcp_conn_addref(conn);
-	fibril_mutex_lock(&conn_list_lock);
+	fibril_mutex_lock(&amap_lock);
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_conn_add: conn=%p", conn);
@@ -278,11 +316,11 @@
 	if (rc != EOK) {
 		tcp_conn_delref(conn);
-		fibril_mutex_unlock(&conn_list_lock);
+		fibril_mutex_unlock(&amap_lock);
 		return rc;
 	}
 
 	conn->ident = aepp;
-	list_append(&conn->link, &conn_list);
-	fibril_mutex_unlock(&conn_list_lock);
+	conn->mapped = true;
+	fibril_mutex_unlock(&amap_lock);
 
 	return EOK;
@@ -293,10 +331,13 @@
  * Remove connection from the connection map.
  */
-void tcp_conn_remove(tcp_conn_t *conn)
-{
-	fibril_mutex_lock(&conn_list_lock);
+static void tcp_conn_remove(tcp_conn_t *conn)
+{
+	if (!conn->mapped)
+		return;
+
+	fibril_mutex_lock(&amap_lock);
 	amap_remove(amap, &conn->ident);
-	list_remove(&conn->link);
-	fibril_mutex_unlock(&conn_list_lock);
+	conn->mapped = false;
+	fibril_mutex_unlock(&amap_lock);
 	tcp_conn_delref(conn);
 }
@@ -335,4 +376,6 @@
 void tcp_conn_sync(tcp_conn_t *conn)
 {
+	assert(fibril_mutex_is_locked(&conn->lock));
+
 	/* XXX select ISS */
 	conn->iss = 1;
@@ -388,10 +431,10 @@
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_conn_find_ref(%p)", epp);
 
-	fibril_mutex_lock(&conn_list_lock);
+	fibril_mutex_lock(&amap_lock);
 
 	rc = amap_find_match(amap, epp, &arg);
 	if (rc != EOK) {
 		assert(rc == ENOENT);
-		fibril_mutex_unlock(&conn_list_lock);
+		fibril_mutex_unlock(&amap_lock);
 		return NULL;
 	}
@@ -400,5 +443,5 @@
 	tcp_conn_addref(conn);
 
-	fibril_mutex_unlock(&conn_list_lock);
+	fibril_mutex_unlock(&amap_lock);
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_conn_find_ref: got conn=%p",
 	    conn);
@@ -412,5 +455,11 @@
 void tcp_conn_reset(tcp_conn_t *conn)
 {
+	assert(fibril_mutex_is_locked(&conn->lock));
+
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "%s: tcp_conn_reset()", conn->name);
+
+	if (conn->cstate == st_closed)
+		return;
+
 	conn->reset = true;
 	tcp_conn_state_set(conn, st_closed);
@@ -865,5 +914,10 @@
 		return cp_done;
 
-	/* TODO */
+	if (conn->fin_is_acked) {
+		log_msg(LOG_DEFAULT, LVL_DEBUG, "%s: FIN acked -> Time-Wait",
+		    conn->name);
+		tcp_conn_state_set(conn, st_time_wait);
+	}
+
 	return cp_continue;
 }
@@ -1062,9 +1116,9 @@
 		log_msg(LOG_DEFAULT, LVL_DEBUG, " - FIN found in segment.");
 
+		conn->rcv_nxt++;
+		conn->rcv_wnd--;
+
 		/* Send ACK */
 		tcp_tqueue_ctrl_seg(conn, CTL_ACK);
-
-		conn->rcv_nxt++;
-		conn->rcv_wnd--;
 
 		/* Change connection state */
@@ -1211,5 +1265,5 @@
 
 		/* Need to remove and re-insert connection with new identity */
-		fibril_mutex_lock(&conn_list_lock);
+		fibril_mutex_lock(&amap_lock);
 
 		if (inet_addr_is_any(&conn->ident.remote.addr))
@@ -1227,5 +1281,5 @@
 			assert(rc == ENOMEM);
 			log_msg(LOG_DEFAULT, LVL_ERROR, "Out of memory.");
-			fibril_mutex_unlock(&conn_list_lock);
+			fibril_mutex_unlock(&amap_lock);
 			tcp_conn_unlock(conn);
 			return;
@@ -1233,5 +1287,5 @@
 
 		amap_remove(amap, &oldepp);
-		fibril_mutex_unlock(&conn_list_lock);
+		fibril_mutex_unlock(&amap_lock);
 
 		conn->name = (char *) "a";
@@ -1322,5 +1376,5 @@
  * @param seg		Segment
  */
-void tcp_conn_trim_seg_to_wnd(tcp_conn_t *conn, tcp_segment_t *seg)
+static void tcp_conn_trim_seg_to_wnd(tcp_conn_t *conn, tcp_segment_t *seg)
 {
 	uint32_t left, right;
@@ -1346,4 +1400,61 @@
 }
 
+/** Transmit segment over network.
+ *
+ * @param epp Endpoint pair with source and destination information
+ * @param seg Segment (ownership retained by caller)
+ */
+static void tcp_transmit_segment(inet_ep2_t *epp, tcp_segment_t *seg)
+{
+	tcp_pdu_t *pdu;
+	tcp_segment_t *dseg;
+	inet_ep2_t rident;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG,
+	    "tcp_transmit_segment(l:(%u),f:(%u), %p)",
+	    epp->local.port, epp->remote.port, seg);
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "SEG.SEQ=%" PRIu32 ", SEG.WND=%" PRIu32,
+	    seg->seq, seg->wnd);
+
+	tcp_segment_dump(seg);
+
+	if (tcp_conn_lb == tcp_lb_segment) {
+		/* Loop back segment */
+//		tcp_ncsim_bounce_seg(sp, seg);
+
+		/* Reverse the identification */
+		tcp_ep2_flipped(epp, &rident);
+
+		/* Insert segment back into rqueue */
+		dseg = tcp_segment_dup(seg);
+		tcp_rqueue_insert_seg(&rident, dseg);
+		return;
+	}
+
+	if (tcp_pdu_encode(epp, seg, &pdu) != EOK) {
+		log_msg(LOG_DEFAULT, LVL_WARN, "Not enough memory. Segment dropped.");
+		return;
+	}
+
+	if (tcp_conn_lb == tcp_lb_pdu) {
+		/* Loop back PDU */
+		if (tcp_pdu_decode(pdu, &rident, &dseg) != EOK) {
+			log_msg(LOG_DEFAULT, LVL_WARN, "Not enough memory. Segment dropped.");
+			tcp_pdu_delete(pdu);
+			return;
+		}
+
+		tcp_pdu_delete(pdu);
+
+		/* Insert decoded segment into rqueue */
+		tcp_rqueue_insert_seg(&rident, dseg);
+		return;
+	}
+
+	tcp_transmit_pdu(pdu);
+	tcp_pdu_delete(pdu);
+}
+
 /** Compute flipped endpoint pair for response.
  *
@@ -1364,5 +1475,5 @@
  * @param seg		Incoming segment
  */
-void tcp_reply_rst(inet_ep2_t *epp, tcp_segment_t *seg)
+static void tcp_reply_rst(inet_ep2_t *epp, tcp_segment_t *seg)
 {
 	tcp_segment_t *rseg;
Index: uspace/srv/net/tcp/conn.h
===================================================================
--- uspace/srv/net/tcp/conn.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/tcp/conn.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -41,12 +41,11 @@
 
 extern int tcp_conns_init(void);
+extern void tcp_conns_fini(void);
 extern tcp_conn_t *tcp_conn_new(inet_ep2_t *);
 extern void tcp_conn_delete(tcp_conn_t *);
 extern int tcp_conn_add(tcp_conn_t *);
-extern void tcp_conn_remove(tcp_conn_t *);
 extern void tcp_conn_reset(tcp_conn_t *conn);
 extern void tcp_conn_sync(tcp_conn_t *);
 extern void tcp_conn_fin_sent(tcp_conn_t *);
-extern void tcp_conn_ack_of_fin_rcvd(tcp_conn_t *);
 extern tcp_conn_t *tcp_conn_find_ref(inet_ep2_t *);
 extern void tcp_conn_addref(tcp_conn_t *);
@@ -57,8 +56,8 @@
 extern void tcp_conn_segment_arrived(tcp_conn_t *, inet_ep2_t *,
     tcp_segment_t *);
-extern void tcp_conn_trim_seg_to_wnd(tcp_conn_t *, tcp_segment_t *);
 extern void tcp_unexpected_segment(inet_ep2_t *, tcp_segment_t *);
 extern void tcp_ep2_flipped(inet_ep2_t *, inet_ep2_t *);
-extern void tcp_reply_rst(inet_ep2_t *, tcp_segment_t *);
+
+extern tcp_lb_t tcp_conn_lb;
 
 #endif
Index: uspace/srv/net/tcp/inet.c
===================================================================
--- uspace/srv/net/tcp/inet.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/srv/net/tcp/inet.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,188 @@
+/*
+ * Copyright (c) 2015 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup tcp
+ * @{
+ */
+
+/**
+ * @file TCP inet interfacing
+ */
+
+#include <bitops.h>
+#include <byteorder.h>
+#include <errno.h>
+#include <inet/inet.h>
+#include <mem.h>
+#include <io/log.h>
+#include <stdlib.h>
+
+#include "inet.h"
+#include "pdu.h"
+#include "rqueue.h"
+#include "std.h"
+
+#define NAME       "tcp"
+
+static int tcp_inet_ev_recv(inet_dgram_t *dgram);
+static void tcp_received_pdu(tcp_pdu_t *pdu);
+
+static inet_ev_ops_t tcp_inet_ev_ops = {
+	.recv = tcp_inet_ev_recv
+};
+
+/** Received datagram callback */
+static int tcp_inet_ev_recv(inet_dgram_t *dgram)
+{
+	uint8_t *pdu_raw;
+	size_t pdu_raw_size;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_inet_ev_recv()");
+
+	pdu_raw = dgram->data;
+	pdu_raw_size = dgram->size;
+
+	/* Split into header and payload. */
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_inet_ev_recv() - split header/payload");
+
+	tcp_pdu_t *pdu;
+	size_t hdr_size;
+	tcp_header_t *hdr;
+	uint32_t data_offset;
+
+	if (pdu_raw_size < sizeof(tcp_header_t)) {
+		log_msg(LOG_DEFAULT, LVL_WARN, "pdu_raw_size = %zu < sizeof(tcp_header_t) = %zu",
+		    pdu_raw_size, sizeof(tcp_header_t));
+		return EINVAL;
+	}
+
+	hdr = (tcp_header_t *)pdu_raw;
+	data_offset = BIT_RANGE_EXTRACT(uint32_t, DF_DATA_OFFSET_h, DF_DATA_OFFSET_l,
+	    uint16_t_be2host(hdr->doff_flags));
+
+	hdr_size = sizeof(uint32_t) * data_offset;
+
+	if (pdu_raw_size < hdr_size) {
+		log_msg(LOG_DEFAULT, LVL_WARN, "pdu_raw_size = %zu < hdr_size = %zu",
+		    pdu_raw_size, hdr_size);
+		return EINVAL;
+	}
+
+	if (hdr_size < sizeof(tcp_header_t)) {
+		log_msg(LOG_DEFAULT, LVL_WARN, "hdr_size = %zu < sizeof(tcp_header_t) = %zu",
+		    hdr_size, sizeof(tcp_header_t));		return EINVAL;
+	}
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "pdu_raw_size=%zu, hdr_size=%zu",
+	    pdu_raw_size, hdr_size);
+	pdu = tcp_pdu_create(pdu_raw, hdr_size, pdu_raw + hdr_size,
+	    pdu_raw_size - hdr_size);
+	if (pdu == NULL) {
+		log_msg(LOG_DEFAULT, LVL_WARN, "Failed creating PDU. Dropped.");
+		return ENOMEM;
+	}
+
+	pdu->src = dgram->src;
+	pdu->dest = dgram->dest;
+
+	tcp_received_pdu(pdu);
+	tcp_pdu_delete(pdu);
+
+	return EOK;
+}
+
+/** Transmit PDU over network layer. */
+void tcp_transmit_pdu(tcp_pdu_t *pdu)
+{
+	int rc;
+	uint8_t *pdu_raw;
+	size_t pdu_raw_size;
+	inet_dgram_t dgram;
+
+	pdu_raw_size = pdu->header_size + pdu->text_size;
+	pdu_raw = malloc(pdu_raw_size);
+	if (pdu_raw == NULL) {
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed to transmit PDU. Out of memory.");
+		return;
+	}
+
+	memcpy(pdu_raw, pdu->header, pdu->header_size);
+	memcpy(pdu_raw + pdu->header_size, pdu->text,
+	    pdu->text_size);
+
+	dgram.iplink = 0;
+	dgram.src = pdu->src;
+	dgram.dest = pdu->dest;
+	dgram.tos = 0;
+	dgram.data = pdu_raw;
+	dgram.size = pdu_raw_size;
+
+	rc = inet_send(&dgram, INET_TTL_MAX, 0);
+	if (rc != EOK)
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed to transmit PDU.");
+
+	free(pdu_raw);
+}
+
+/** Process received PDU. */
+static void tcp_received_pdu(tcp_pdu_t *pdu)
+{
+	tcp_segment_t *dseg;
+	inet_ep2_t rident;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_received_pdu()");
+
+	if (tcp_pdu_decode(pdu, &rident, &dseg) != EOK) {
+		log_msg(LOG_DEFAULT, LVL_WARN, "Not enough memory. PDU dropped.");
+		return;
+	}
+
+	/* Insert decoded segment into rqueue */
+	tcp_rqueue_insert_seg(&rident, dseg);
+}
+
+/** Initialize TCP inet interface. */
+int tcp_inet_init(void)
+{
+	int rc;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_inet_init()");
+
+	rc = inet_init(IP_PROTO_TCP, &tcp_inet_ev_ops);
+	if (rc != EOK) {
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed connecting to internet service.");
+		return ENOENT;
+	}
+
+	return EOK;
+}
+
+/**
+ * @}
+ */
Index: uspace/srv/net/tcp/inet.h
===================================================================
--- uspace/srv/net/tcp/inet.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/srv/net/tcp/inet.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2015 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup tcp
+ * @{
+ */
+/** @file TCP inet interfacing
+ */
+
+#ifndef TCP_INET_H
+#define TCP_INET_H
+
+#include "tcp_type.h"
+
+extern int tcp_inet_init(void);
+extern void tcp_transmit_pdu(tcp_pdu_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/srv/net/tcp/iqueue.c
===================================================================
--- uspace/srv/net/tcp/iqueue.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/tcp/iqueue.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -84,6 +84,8 @@
 		    tcp_iqueue_entry_t, link);
 
-		if (seq_no_seg_cmp(iqueue->conn, iqe->seg, qe->seg) >= 0)
+		if (seq_no_seg_cmp(iqueue->conn, iqe->seg, qe->seg) < 0)
 			break;
+
+		link = list_next(link, &iqueue->list);
 	}
 
@@ -92,4 +94,36 @@
 	else
 		list_append(&iqe->link, &iqueue->list);
+}
+
+/** Remove segment from incoming queue.
+ *
+ * @param iqueue	Incoming queue
+ * @param seg		Segment
+ */
+void tcp_iqueue_remove_seg(tcp_iqueue_t *iqueue, tcp_segment_t *seg)
+{
+	tcp_iqueue_entry_t *qe;
+	link_t *link;
+
+	log_msg(LOG_DEFAULT, LVL_NOTE, "tcp_iqueue_remove_seg()");
+
+	link = list_first(&iqueue->list);
+	while (link != NULL) {
+			log_msg(LOG_DEFAULT, LVL_NOTE, "tcp_iqueue_remove_seg() - next");
+		qe = list_get_instance(link,
+		    tcp_iqueue_entry_t, link);
+
+		if (qe->seg == seg) {
+			log_msg(LOG_DEFAULT, LVL_NOTE, "tcp_iqueue_remove_seg() - found, DONE");
+			list_remove(&qe->link);
+			free(qe);
+			return;
+		}
+
+		link = list_next(link, &iqueue->list);
+	}
+
+	log_msg(LOG_DEFAULT, LVL_NOTE, "tcp_iqueue_remove_seg() - not found");
+	assert(false);
 }
 
Index: uspace/srv/net/tcp/iqueue.h
===================================================================
--- uspace/srv/net/tcp/iqueue.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/tcp/iqueue.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -40,4 +40,5 @@
 extern void tcp_iqueue_init(tcp_iqueue_t *, tcp_conn_t *);
 extern void tcp_iqueue_insert_seg(tcp_iqueue_t *, tcp_segment_t *);
+extern void tcp_iqueue_remove_seg(tcp_iqueue_t *, tcp_segment_t *);
 extern int tcp_iqueue_get_ready_seg(tcp_iqueue_t *, tcp_segment_t **);
 
Index: uspace/srv/net/tcp/ncsim.c
===================================================================
--- uspace/srv/net/tcp/ncsim.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/tcp/ncsim.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -73,8 +73,10 @@
 	tcp_squeue_entry_t *sqe;
 	tcp_squeue_entry_t *old_qe;
+	inet_ep2_t rident;
 	link_t *link;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_ncsim_bounce_seg()");
-	tcp_rqueue_bounce_seg(epp, seg);
+	tcp_ep2_flipped(epp, &rident);
+	tcp_rqueue_insert_seg(&rident, seg);
 	return;
 
@@ -125,4 +127,5 @@
 	link_t *link;
 	tcp_squeue_entry_t *sqe;
+	inet_ep2_t rident;
 	int rc;
 
@@ -148,5 +151,6 @@
 
 		log_msg(LOG_DEFAULT, LVL_DEBUG, "NCSim - End Sleep");
-		tcp_rqueue_bounce_seg(&sqe->epp, sqe->seg);
+		tcp_ep2_flipped(&sqe->epp, &rident);
+		tcp_rqueue_insert_seg(&rident, sqe->seg);
 		free(sqe);
 	}
